//--------------------------------------------------------------------
// i-Speed.mq4
//--------------------------------------------------------------------
#property indicator_chart_window       // .    
#property indicator_buffers 6          //  
#property indicator_color1 Blue        //   0 
#property indicator_color2 DarkOrange  //  1 
#property indicator_color3 Red         //  2 ,  1 
#property indicator_color4 Green       //  3  peak[]
#property indicator_color5 Red         //  4  trough[]
//--------------------------------------------------------------- 2 --
int History    =5000;               // .   
extern int Period_MA_0=9;           //     . 
extern int Period_MA_1=21;          //   
extern int Bars_V     =9;           // .   
extern int avg        =3;           //    
extern double K       =2;           //  
//--------------------------------------------------------------- 3 --
double
   Line_0[],                        // .   MA
   Line_1[],                        // .   
   Line_2[],
   peak[], trough[], pt[];          //
int n; 
//--------------------------------------------------------------- 4 --
int init()                          //   init()
  {
   SetIndexStyle(3, DRAW_ARROW);
   SetIndexStyle(4, DRAW_ARROW);
  
   SetIndexBuffer(0,Line_0);        //   
   SetIndexBuffer(1,Line_1);        //   
   SetIndexBuffer(2,Line_2);        //   
   SetIndexBuffer(3,peak);          //    Green
   SetIndexBuffer(4,trough);        //    Red
   SetIndexBuffer(5,pt);            //    Red
   
   SetIndexArrow(3, 233);           //   " "  Green 
   SetIndexArrow(4, 234);           //   " "  Red
   return;                          //   .  init()
  }
//--------------------------------------------------------------- 8 --
int start()                         //   start()
  {
//--------------------------------------------------------------- 9 --
   int
   i,j,                            //  
   Counted_bars;                 //    
//-------------------------------------------------------------- 10 --
   Counted_bars=IndicatorCounted(); //    
   j=Bars-Counted_bars-1;           //   
   if (j>History-1)                 //     ..
      j=History-1;                  // ..  .
      
   for (i = j; i >= 0; i--)
      {
       CalculateLine_1(i);
      }   
   for (i = j; i >= 0; i--)
      {
       CalculateLine_2(i);
      }   

   return;                          //   . - start()
  }
//-------------------------------------------------------------- 20 --

//-------------------------------------------------------------- 11 --
void CalculateLine_1 (int i)
     {
      double
      MA_0,                         //     
      MA_c, MA_p;                   //   . . 
      //-------------------------------------------------------- 12 --
      MA_0=iMA(NULL,0,Period_MA_0,0,MODE_SMMA,PRICE_WEIGHTED,i);
      Line_0[i]=MA_0;               //   
      //-------------------------------------------------------- 13 --
      MA_c=iMA(NULL,0,Period_MA_1,0,MODE_SMMA,PRICE_WEIGHTED,i);
      MA_p=iMA(NULL,0,Period_MA_1,0,MODE_SMMA,PRICE_WEIGHTED,i+Bars_V);
      Line_1[i]= MA_0+K*(MA_c-MA_p);//  1  
    }
   
void CalculateLine_2 (int i)
  {
      Line_2[i] = iMAOnArray (Line_1,0,avg,0,MODE_SMA,i);
      
      if (Line_2[i+1] < Line_2[i] && Line_2[i+1] < Line_2[i+2] && Line_2[i+2] < Line_2[i+3])
          {
           peak[i+1] = Line_2[i+1];       //    
           if (pt[n] == peak[n])          //    .   
             {
              peak[n] = EMPTY_VALUE;      //   . ,   .    
             }              // 
              n  = i+1;
              pt[n] = Line_2[i+1];
          }
      if (Line_2[i+1] > Line_2[i] && Line_2[i+1] > Line_2[i+2] && Line_2[i+2] > Line_2[i+3])
          {
           trough[i+1] = Line_2[i+1];
           if (pt[n] == trough[n])          //    .   
             {
              trough[n] = EMPTY_VALUE;      //   . ,   .    
             }              // 
              n  = i+1;
              pt[n] = Line_2[i+1];
          }
  }